<div class="container">
    <div [hidden]="submitted">
        <h1>Register</h1>
    <form (ngSubmit)="onSubmit()" novalidate [formGroup]="myform">
  
        <div formGroupName="name">
            <div class="form-group">
                <label>First Name</label><br>
                <input type="text" formControlName="firstName" required>
                <div *ngIf="firstName.errors && (firstName.dirty || firstName.touched)">
                    <div class="error" *ngIf="firstName.errors.required">First Name is required</div>
                </div>
            </div>

            <div class="form-group">
                <label>Last Name</label><br>
                <input type="text" formControlName="lastName" required>
                <div *ngIf="lastName.errors && (lastName.dirty || lastName.touched)">
                    <div class="error" *ngIf="lastName.errors.required">Last Name is required</div>
                </div>
            </div>

            <div class="form-group">
                <label>Username</label><br>
                <input type="text" formControlName="username" required>
                <div *ngIf="username.errors && (username.dirty || username.touched)">
                    <div class="error" *ngIf="username.errors.required">Username is required</div>
                </div>
            </div>
        </div>
    
        <div>
            <label>Email</label><br>
            <input type="email" formControlName="email" required>
            <div *ngIf="email.errors && (email.dirty || email.touched)">
                <div class="error" *ngIf="email.errors.required">Email is required</div>
                <div class="error" *ngIf="email.errors.pattern">The email address must contain at least the @ character</div>
            </div>
        </div>
    
        <div>
            <label>Password</label><br>
            <input type="password" formControlName="password" required>
            <div *ngIf="password.errors && (password.dirty || password.touched)">
                <div class="error" *ngIf="password.errors.required">Password is required</div>
                <div class="error" *ngIf="password.errors.minlength">Password must be at least 8 characters long</div>
            </div>
        </div>
        <button type="submit" class="btn btn-success" [disabled]="!myform.valid">Submit</button>
    </form>
    </div>
</div>